/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class GebietsgruppierungDAO extends AbstractGebietsgruppierungDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Gebietsgruppierung gebietsgruppierung){
    getEntityManager().persist(gebietsgruppierung);
  }

  public void remove(Gebietsgruppierung gebietsgruppierung){
    getEntityManager().remove(gebietsgruppierung);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: WahlAndGebietsgruppierungArtenNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahl = ?1 AND obj.gebietsgruppierungArt IN (?2)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Gebietsgruppierung> findByWahlAndGebietsgruppierungArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<String> gebietsgruppierungArten) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahlAndGebietsgruppierungArten" ,  wahl ,  gebietsgruppierungArten  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlAndGebietsgruppierungArten( wahl ,  gebietsgruppierungArten  ));
        }
        return (java.util.List<Gebietsgruppierung>) cached;
        }
            return super.findByWahlAndGebietsgruppierungArten( wahl ,  gebietsgruppierungArten  );
            }
                                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahl = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Gebietsgruppierung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Gebietsgruppierung>) cached;
        }
            return super.findByWahl( wahl  );
            }
                                        
        /**
        * Name: WahlterminAndGebietsgruppierungArtenNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahltermin = ?1 AND obj.gebietsgruppierungArt IN (?2)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Gebietsgruppierung> findByWahlterminAndGebietsgruppierungArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull java.util.Collection<String> gebietsgruppierungArten) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahlterminAndGebietsgruppierungArten" ,  wahltermin ,  gebietsgruppierungArten  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlterminAndGebietsgruppierungArten( wahltermin ,  gebietsgruppierungArten  ));
        }
        return (java.util.List<Gebietsgruppierung>) cached;
        }
            return super.findByWahlterminAndGebietsgruppierungArten( wahltermin ,  gebietsgruppierungArten  );
            }
                                        
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}